CREATE TABLE student
(
    id         INTEGER GENERATED BY DEFAULT AS IDENTITY NOT NULL,
    first_name VARCHAR(255),
    last_name  VARCHAR(255),
    CONSTRAINT pk_student PRIMARY KEY (id)
);

CREATE TABLE teacher
(
    id         INTEGER GENERATED BY DEFAULT AS IDENTITY NOT NULL,
    first_name VARCHAR(255),
    last_name  VARCHAR(255),
    CONSTRAINT pk_teacher PRIMARY KEY (id)
);

CREATE TABLE teacher_student
(
    student_id INTEGER NOT NULL,
    teacher_id INTEGER NOT NULL,
    CONSTRAINT pk_teacher_student PRIMARY KEY (student_id, teacher_id)
);

ALTER TABLE teacher_student
    ADD CONSTRAINT fk_teastu_on_student FOREIGN KEY (student_id) REFERENCES student (id);

ALTER TABLE teacher_student
    ADD CONSTRAINT fk_teastu_on_teacher FOREIGN KEY (teacher_id) REFERENCES teacher (id);
